#!/usr/bin/perl

usage() unless @ARGV;
 
require Startup;		# Ldt das Startup-Modul zur Laufzeit
require OLE::Storage; 		# Ldt das OLE::Storage-Modul zur Laufzeit

my $Start = new Startup;	# Globales Startup-Objekt
my $Var = NewVar OLE::Storage;	# Globales Var-Objekt
my $Doc;			# Globale Dokumenten-Variable

foreach $file (@ARGV) {
   # Initialisiert die Message-Methoden von Startup, gibt eine Startmeldung aus.
   $Start -> msg_reset -> msg_nl ("Processing $file");

   # ffnet das Compound-Dokument
   $Doc = OLE::Storage -> open ($Start, $Var, $file);

   # Bei einem Fehler ist $Doc == 0. msg_error gibt dann die Fehlermeldung
   # aus, die OLE::Storage dem Objekt $Start mitgeteilt hat. Da msg_error
   # immer 0 zurckgibt, geht es mit dem nchsten Element von @ARGV weiter.
   next unless $Doc || $Start->msg_error();

   # Da kein Fehler auftrat, ist $Doc nun ein OLE::Storage-Objekt. traverse
   # untersucht jetzt die Dokumentenstruktur und beginnt mit dem Handle 0, 
   # das immer dem Root-Directory zugeordnet ist. Die 1 gibt an, wieviele
   # Level die Ausgabe eingerckt werden soll.
   traverse (0, 1);

   $Start -> msg_finish("done");
}
exit 1;

sub usage {
   print "usage: lls-mini doc(s)\n";
   print "Listet die Struktur von OLE-Compound-Dokumenten auf.\n";
   exit 0;
}

sub traverse {
#
# traverse wird rekursiv aufgerufen. Parameter 1 ist ein Directory-handle bzw. 
# das Root-handle 0. Parameter 2 gibt die Einrcktiefe fr die Textausgabe an.
#
   my ($dir_handle, $indent_level) = @_;
   my $indent = " " x 3 x $indent_level;

   # $Doc->dirhandles liefert eine Liste aller Eintrge von $dir_handle.
   foreach $handle ($Doc->dirhandles($dir_handle)) {

      # $Doc->name liefert eine Unicode-Property, string macht daraus einen 
      # String. Die Sonderzeichen 0 bis 31 werden dann durch " " ersetzt.
      my $name = $Doc->name($handle)->string;
      $name =~ s/[\x00-\x31]/ /g;

      if ($Doc->is_file($handle)) {
         # handle ist ein File. Name und Gre wird ausgegeben.
         print "$indent'$name' (".$Doc->size($handle)." bytes)\n";
      } elsif ($Doc->is_directory($handle)) {
         # handle ist ein weiteres Directory => nchste Rekursionsstufe.
         print "$indent'$name' (DIR)\n";
         traverse ($handle, $indent_level+1);
      }
   }
1}

