#!/usr/bin/perl

my $plain_phrase = "Times New Roman";
my ($Start, $Var, $buf, %dir, $pw);

main: {
   usage() unless @ARGV;
   require Startup; $Start = new Startup;
   require OLE::Storage; $Var = NewVar OLE::Storage;
   for (@ARGV) {
      $Start -> msg_reset -> msg ("Processing $_");
      $Doc = OLE::Storage -> open ($Start, $Var, $_);
      next if !($Doc || error());
      next if !(examine($Doc) || error());
      $Start -> msg_finish("done");
   }
   exit 1;
}

sub usage {
   print "usage: getpasswd doc(s)\n".
      "Very simple try to guess passwords of Word6 and Word7 documents.\n";
   exit 0;
}

sub error {
   $Start -> msg_error() if $Start;
0}

sub examine {
   my ($Doc) = @_;
   $buf=""; %dir=();
   return 0 unless $Doc -> directory (0, \%dir, "string");
   return $Start -> error("Not a word document.") 
     unless $dir{"WordDocument"};
   return 0 unless $Doc -> read ($dir{"WordDocument"}, \$buf);
   return 0 unless (my $sure = get_password());
   $Start -> msg("Password is".($sure==1?" something like":"").": '$pw'");
1}

sub get_password {
   my ($status, $qq, $hash, @pwkey) = 
     unpack("v3C2", substr($buf, 0x0a, 8));
   my $crypt_phrase; my $b; $pw=""; my $h=0xce4b;
   my $phrase_len = length($plain_phrase);
   return $Start -> error ("Document not crypted.") 
     unless ($status & 2**8);

   my $pattern = '\0([^\0]{'.$phrase_len.'})\0';
   while ($buf =~ /$pattern/g) { 
     $crypt_phrase = $1 
   }
   return $Start -> error ("Cannot decrypt document.") 
     unless $crypt_phrase;

   $shift = rindex($buf, $crypt_phrase) % 16;
   %key = ();
   for (0..$phrase_len-1) {
      $key{($_+$shift)%16} = 
         unpack("C", substr($crypt_phrase, $_, 1)) ^
         unpack("C", substr($plain_phrase, $_, 1))
      ;
   }
   return 1 if $h == $hash;

   for (0..$phrase_len-1) {
      if (defined $key{$_}) {
         $b = rol($key{$_},1,8) ^ $pwkey[$_&1];
         $h ^= (rol($b,$_+1,15) ^ ($_+1) ^ $_);
         $pw .= pack("C", $b);
         return 2 if $h == $hash;
      } else {
         $Start -> msg_warn("1 password character not figured out");
         $pw .= "."; $hash=0;
      }
   }
1}

sub rol {
   my ($n, $num, $bitlen) = @_;
   return $n if !$num; $num %= $bitlen;
   ($n * 2**$num) & (2**$bitlen-1) | ( ($n * 2**($num-$bitlen)) );
}
